using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace ColorConverter
{
  public partial class FormCapture : Form
  {
    private int fGlobalMouseX = 0;
    private int fGlobalMouseY = 0;

    private Bitmap fScreenBmp;
    private Bitmap fPb1Bmp;
    private Color fScreenColor = Color.Black;

    [DllImport("user32.dll")]
    static extern bool GetCursorPos(ref Point lpPoint);

    private FormMaster fFormMaster = null;

    public FormCapture(FormMaster formMaster)
    {
      fFormMaster = formMaster;      
      InitializeComponent();
    }

    private void getColorFromScreen()
    {
      Graphics g1 = Graphics.FromImage(fScreenBmp);
      Graphics g2 = Graphics.FromImage(fPb1Bmp);

      try
      {
        g1.CopyFromScreen(new Point(0, 0), new Point(0, 0), fScreenBmp.Size);

        fScreenColor = fScreenBmp.GetPixel(fGlobalMouseX, fGlobalMouseY);

        g2.Clear(Color.FromArgb(fScreenColor.R, fScreenColor.G, fScreenColor.B));
        pictureBox1.Image = fPb1Bmp;

        label5.Text = fScreenColor.R.ToString();
        label6.Text = fScreenColor.G.ToString();
        label7.Text = fScreenColor.B.ToString();
      }
      catch
      {
      }

      g1.Dispose();
      g2.Dispose();
    }

    private void getGlobalMouseCoords()
    {
      Point defPnt = new Point();
      GetCursorPos(ref defPnt);

      fGlobalMouseX = defPnt.X;
      fGlobalMouseY = defPnt.Y;
    }

    private void timer1_Tick(object sender, EventArgs e)
    {
      getGlobalMouseCoords();
      getColorFromScreen();
    }

    private void FormCapture_Load(object sender, EventArgs e)
    {
      fScreenBmp = new Bitmap(Screen.PrimaryScreen.Bounds.Width, Screen.PrimaryScreen.Bounds.Height);
      fPb1Bmp = new Bitmap(pictureBox1.Width, pictureBox1.Height);
      Graphics g = Graphics.FromImage(fPb1Bmp);
      g.Clear(Color.Black);
      g.Dispose();
    }

    private void FormCapture_Shown(object sender, EventArgs e)
    {
      timer1.Enabled = true;
    }

    private void FormCapture_FormClosing(object sender, FormClosingEventArgs e)
    {
      timer1.Enabled = false;
      fFormMaster.SetColor(fScreenColor.R, fScreenColor.G, fScreenColor.B);
      fFormMaster.SetToolTipAndLabel();
      fFormMaster.ConvertColor();
      this.Hide();
      fFormMaster.Show();
    }

    private void FormCapture_KeyUp(object sender, KeyEventArgs e)
    {
      if (e.KeyCode == Keys.F1)
      {       
        this.Close();
      }
    }

  
  }
}